<template>
	<div class="q-pa-md q-gutter-sm">
		<q-dialog v-model="taskAdd" class="dialog">
			<q-card style="width: 500px;">
				<form>
					<div class="row">
						<q-card-section> </q-card-section>
						<q-space />
						<q-card-section>
							<q-btn round dense icon="close" v-close-popup />
						</q-card-section>
					</div>

					<q-card-section class="q-pt-none">
						<q-table
							title="User list"
							:data="users"
							:columns="columns"
							row-key="name"
						>
							<template v-slot:body="props">
								<q-tr :props="props">
									<q-td key="name" :props="props">
										{{ props.row.USERNAME }}
									</q-td>
									<q-td key="assign" :props="props">
										<q-btn
											color="primary"
											label="Assign task"
											size="sm"
											@click="
												userAddTask({
													userId: props.row.USER_ID,
													userName:
														props.row.USERNAME,
													addForm: true,
													addTask: false,
												})
											"
										/>
									</q-td>
								</q-tr>
							</template>
						</q-table>
					</q-card-section>
				</form>
			</q-card>
		</q-dialog>
	</div>
</template>

<script>
import { mapActions } from "vuex";
import { mapGetters } from "vuex";
export default {
	data() {
		return {
			columns: [
				{
					name: "name",
					required: true,
					label: "Username",
					align: "left",
					field: (row) => row.name,
					format: (val) => `${val}`,
					sortable: true,
				},
				{
					name: "assign",
					label: "Assign",
					align: "center",
					field: "assign",
				},
			],
			users: [],
		};
	},
	methods: {
		...mapActions({
			userAddTask: "showcase/userAddTask",
		}),
		getUserData() {
			this.$axios
				.get(this.host + "/src/php/actions/user.php", {
					withCredentials: true,
				})
				.then((response) => {
					this.users = response.data;
				});
		},
	},
	computed: {
		...mapGetters({
			AddTask: "showcase/taskAdd",
		}),
		taskAdd: {
			get() {
				return this.AddTask;
			},
			set() {
				this.$store.commit("showcase/hideAddDialog");
			},
		},
	},
	created() {
		this.getUserData();
	},
};
</script>
